#define _XOPEN_SOURCE 1
#define _XOPEN_SOURCE_EXTENDED 1
#include <sys/ioctl.h>

#ifdef TIOCCONS

int grabconsole(int fd) {
  int x=1;
  if (ioctl(fd, TIOCCONS, (char*)&x)!=0)
    return grabconsole_ioctl;
  return grabconsole_success;
}

#else

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/strredir.h>
#include <errno.h>

int grabconsole(int fd) {
  int const console=open("/dev/console", O_RDONLY);
  if (console<0)
    return grabconsole_devconsole_open;
  if (ioctl(console, SRIOCSREDIR, fd)!=0) {
    int const error=errno;
    close(console);
    errno=error;
    return grabconsole_ioctl;
  }
  if (close(console)!=0)
    return grabconsole_devconsole_close;
  return grabconsole_success;
}

#endif
